%global cmakename qrcodegen-cmake
%global cmakesuffix cmake1

Summary: High-quality QR Code generator library
Name: qr-code-generator
Version: 1.8.0
Release: 2%{?dist}
License: MIT
URL: https://github.com/nayuki/QR-Code-generator
Source0: %{url}/archive/v%{version}/%{name}-%{version}.tar.gz
Source1: https://github.com/EasyCoding/%{cmakename}/archive/v%{version}-%{cmakesuffix}/%{cmakename}-%{version}-%{cmakesuffix}.tar.gz

BuildRequires: cmake gcc gcc-c++ ninja-build
BuildRequires: python3-devel python3-setuptools

%description
This package aims to provide the best, clearest QR Code generator library in multiple languages.

%package -n libqrcodegen
Summary: High-quality QR Code generator library (plain C version)

%description -n libqrcodegen
This package aims to provide the best, clearest QR Code generator library in multiple languages.

%package -n libqrcodegen-devel
Summary: Development files for libqrcodegen
Requires: libqrcodegen = %{version}-%{release}

%description -n libqrcodegen-devel
This package provides development files and headers for high-quality QR Code generator library 
(plain C version).

%package -n libqrcodegencpp
Summary: High-quality QR Code generator library (C++ version)

%description -n libqrcodegencpp
This package aims to provide the best, clearest QR Code generator library in multiple languages.

%package -n libqrcodegencpp-devel
Summary: Development files for libqrcodegencpp
Requires: libqrcodegencpp = %{version}-%{release}

%description -n libqrcodegencpp-devel
This package provides development files and headers for high-quality QR Code generator library 
(C++ version).

%package -n python3-qrcodegen
Summary: High-quality QR Code generator library (Python version)
BuildArch: noarch
Provides: python3-qrcodegen = %{version}-%{release}

%description -n python3-qrcodegen
This package aims to provide the best, clearest QR Code generator library in multiple languages.

%prep
%autosetup -n QR-Code-generator-%{version}

tar -xf %{SOURCE1} %{cmakename}-%{version}-%{cmakesuffix}/cmake %{cmakename}-%{version}-%{cmakesuffix}/CMakeLists.txt --strip=1

%build
%cmake -G Ninja -DCMAKE_BUILD_TYPE=Release -DBUILD_TESTS:BOOL=ON
%cmake_build

pushd python
%py3_build
popd

%check
%ctest

%install
%cmake_install

pushd python
%py3_install
popd

ln -s qrcodegen.hpp %{buildroot}%{_includedir}/qrcodegencpp/QrCode.hpp

%files -n libqrcodegen
%license Readme.markdown
%{_libdir}/libqrcodegen.so.1*

%files -n libqrcodegen-devel
%{_includedir}/qrcodegen/
%{_libdir}/cmake/qrcodegen/
%{_libdir}/libqrcodegen.so
%{_libdir}/pkgconfig/qrcodegen.pc

%files -n libqrcodegencpp
%license Readme.markdown
%{_libdir}/libqrcodegencpp.so.1*

%files -n libqrcodegencpp-devel
%{_includedir}/qrcodegencpp/
%{_libdir}/cmake/qrcodegencpp/
%{_libdir}/libqrcodegencpp.so
%{_libdir}/pkgconfig/qrcodegencpp.pc

%files -n python3-qrcodegen
%license Readme.markdown
%{python3_sitelib}/qrcodegen.py
%{python3_sitelib}/__pycache__/*
%{python3_sitelib}/qrcodegen-*.egg-info/

%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.8.0-2
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 Wang Guodong <gordonwwang@tencent.com> - 1.8.0-1
- initial build
